/*
  f-cpu/c/scheduler/decoder.h - decoder ports for the F-CPU simulator
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com
  version: 19 July 2002 13:30

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------

*/

#ifndef DECODER_H
#define DECODER_H

#include <f-cpu_config.h>

#define true     1
#define false    0

/* inputs and outputs : */

/* external FF of fetcher: */
u32  decoder_instr;   /* from fetcher */
u8   decoder_op2;     /* from fetcher */
u8   decoder_op1;     /* from fetcher */
u8   decoder_dst;     /* from fetcher */
u8   decoder_W0_nr;   /* from scheduler */
u8   decoder_W1_nr;   /* from scheduler */
u8   decoder_W0_nr_bis;/* from scheduler */
u8   decoder_W1_nr_bis;/* from scheduler */
u16  decoder_imm;     /* to xbar */
u8   decoder_R0_nr;   /* to xbar */
u8   decoder_R1_nr;   /* to xbar */
u8   decoder_R2_nr;   /* to xbar */
u8   decoder_EU_nr;   /* to xbar */
bool decoder_ADD;     /* to eu_asu */
bool decoder_SUB;     /* to eu_asu */
bool decoder_INC;     /* to eu_inc */
bool decoder_DEC;     /* to eu_inc */

u8   decoder_need_r0_nr; /* add to drawing */
u8   decoder_need_r1_nr;
u8   decoder_need_r2_nr;
u8   decoder_need_cycles;   
u8   decoder_need_w0_nr;
u8   decoder_need_w1_nr;


/* problem : they should be enums !! */

static inline void decoder_cycle(void);

#endif /* DECODER_H */
